//todo: Strategie auswählen : DropDown -> dann override von einzelnen Werten z.B Wakeup message, parity baud
//todo: Comport und Baud über Gui

//todo Word Doku Ablaufbeschreibung

<script type="text/javascript">
    RED.nodes.registerType('pollum-com-e-serial',{
        category: 'function',
        color: '#a6bbcf',
        defaults: {
            name: {value:""},
            comPort: {value:"COM3"},
            comPort_baud: {value:"2400"},
            serial_wakeup_msg: { value:"55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55" },
            serial_wakeup_msg_parity: {value:"none"},
            serial_readyCheck_msg: {value:"10 40 00 40 16"},
            serial_readyCheck_msg_parity:{value: "even"},
            serial_getShortData_msg: {value:"10 5B 00 5B 16"},
            serial_getShortData_msg_parity:{value: "even"},
            serial_getLongData_msg: {value:"10 7B 00 7B 16"},
            serial_getLongData_msg_parity: {value:"even"}

        },
        inputs:1,
        outputs:2,
        icon: "serial.png",
        label: function() {
            return this.name||"pollum-com-e-serial";
        },
        oneditsave: function () {
            testLog("test");
        },

        oneditprepare: function (){
            $("#node-input-serial_wakeup_msg_parity").typedInput({
                types: [
                    {
                        value: "parity",
                        options: [
                            { value: "none", label: "None"},
                            { value: "even", label: "Even"},
                            { value: "odd", label: "Odd"},
                        ]
                    }
                ]
            });
            $("#node-input-serial_readyCheck_msg_parity").typedInput({
                types: [
                    {
                        value: "parity",
                        options: [
                            { value: "none", label: "None"},
                            { value: "even", label: "Even"},
                            { value: "odd", label: "Odd"},
                        ]
                    }
                ]
            });
            $("#node-input-serial_getShortData_msg_parity").typedInput({
                types: [
                    {
                        value: "parity",
                        options: [
                            { value: "none", label: "None"},
                            { value: "even", label: "Even"},
                            { value: "odd", label: "Odd"},
                        ]
                    }
                ]
            });
            $("#node-input-serial_getLongData_msg_parity").typedInput({
                types: [
                    {
                        value: "parity",
                        options: [
                            { value: "none", label: "None"},
                            { value: "even", label: "Even"},
                            { value: "odd", label: "Odd"},
                        ]
                    }
                ]
            });

            var that = this;
            var tabs = RED.tabs.create({
                id: "config-tabs",
                onchange: function(tab) {
                    $("#config-tabs-content").children().hide();
                    $("#" + tab.id).show();
                    let editor = $("#" + tab.id).find('.monaco-editor').first();
                    if(editor.length) {
                        if(that.editor.nodered && that.editor.type == "monaco") {
                            that.editor.nodered.refreshModuleLibs(getLibsList());
                        }
                        RED.tray.resize();
                        //auto focus editor on tab switch
                        if (that.initEditor.getDomNode() == editor[0]) {
                            that.initEditor.focus();
                        } else if (that.editor.getDomNode() == editor[0]) {
                            that.editor.focus();
                        } else if (that.finalizeEditor.getDomNode() == editor[0]) {
                            that.finalizeEditor.focus();
                        }
                    }
                }
            });
        }

    });
</script>

<script type="text/html" data-template-name="pollum-com-e-serial">

    <div class="form-row">
        <label for="node-input-name"><i class="fa fa-tag"></i> Name</label>
        <input type="text" id="node-input-name" placeholder="Name">
    </div>

    <div class="form-row config-tabs-row">
        <ul style="min-width: 300px; margin-bottom: 20px;" id="config-tabs"></ul>
    </div>




    <!-- comPort Config -->
    <div class="form-row">
        <label for="node-input-comPort"><i class="fa fa-random"></i> Serieller Port</label>
        <input type="text" id="node-input-comPort" placeholder="COM3">
    </div>
    <div class="form-row">
        <label for="node-input-comPort_baud"><i class="fa fa-random"></i> Serieller Port</label>
        <input type="text" id="node-input-comPort_baud" placeholder="2400">
    </div>


    <!-- Eingabefeld für Wakeupnachricht und Parität -->
    <div class="form-row">
        <label for="node-input-serial_wakeup_msg"><i class="fa fa-bullhorn"></i> WakeUp Message</label>
        <input type="text" id="node-input-serial_wakeup_msg" placeholder="55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55">
    </div>
    <div class="form-row">
        <label for="node-input-serial_wakeup_msg_parity"><i class="fa fa-exchange "></i> WakeUp Message Parity </label>
        <input type="text" id="node-input-serial_wakeup_msg_parity">
    </div>
    <!-- Eingabefeld für Bereitschaftscheck und Paritöt-->
    <div class="form-row">
        <label for="node-input-serial_readyCheck_msg"><i class="fa fa-tag"></i> Readycheck Message</label>
        <input type="text" id="node-input-serial_readyCheck_msg" placeholder="10 40 00 40 16">
    </div>
    <div class="form-row">
        <label for="node-input-serial_readyCheck_msg_parity"><i class="fa fa-exchange"></i> Readycheck Message Parity </label>
        <input type="text" id="node-input-serial_readyCheck_msg_parity">
    </div>
    <!-- Eingabefeld für Anfrage der kurzen Nachricht und Paritöt-->
    <div class="form-row">
        <label for="node-input-serial_getShortData_msg"><i class="fa fa-tag"></i> getData Message</label>
        <input type="text" id="node-input-serial_getShortData_msg" placeholder="10 5B 00 5B 16">
    </div>
    <div class="form-row">
        <label for="node-input-serial_getShortData_msg_parity"><i class="fa fa-exchange"></i> getData Message Parity </label>
        <input type="text" id="node-input-serial_getShortData_msg_parity">
    </div>
    <!-- Eingabefeld für Anfrage der langen Nachricht und Paritöt-->
    <div class="form-row">
        <label for="node-input-serial_getLongData_msg"><i class="fa fa-tag"></i> getData Message</label>
        <input type="text" id="node-input-serial_getLongData_msg" placeholder="10 7B 00 7B 16">
    </div>
    <div class="form-row">
        <label for="node-input-serial_getLongData_msg_parity"><i class="fa fa-exchange"></i> getData Message Parity </label>
        <input type="text" id="node-input-serial_getLongData_msg_parity">
    </div>

</script>

<script type="text/html" data-help-name="pollum-com-e-serial">
    <p>Dieser Node ist zum Auslesen eines PollumComE Energiezähler gedacht. Es können die Sequenzen für WakeUp, Ansprechen/Bereitschaftsscheck und Zählerabfrage  geändert werden, sowie die Einstellung mit welcher Parität eine Nachricht geschickt wird. Dies ist nötig, da die Wakeup Nachricht ohne Paritätsprüfung geschickt wird und die Folgenachrichten mit Parität 'Even'</p>
    <p>Der Serielle Port wird mit 2400 Baud, 8 Databits und 1 Stopbit geöffnet</p>
    <p>WakeUp Message: Die Bytes in Hex</p>
</script>
